import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This actor handles the fade transition used in the intro and title screen.
 */

public class Fade extends Actor
{   
    private int firstRun = 0;
    private String fadeType;
    
    /**
     * Grabs information from its parent.
     */
    public Fade(String fadeVariant)
    {
        fadeType = fadeVariant;
    }
    
    /**
     * First, checks what type of fade is being requested.
     * 
     * Then, fades either in or out and deletes itself upon completion.
     */
    public void act()
    {
        if(fadeType == "in")
        {
            if(firstRun == 0)
            {
                firstRun = 1;
                getImage().setTransparency(0);
                GreenfootImage image = getImage();
                image.scale(800, 800);
            }
            if (getImage().getTransparency() <= 245)
            {
                fadeIn();
            }
            else
            {
                Greenfoot.delay(10);
                Greenfoot.setWorld(new TitleMenu());
            }
        }
        if(fadeType == "out")
        {
            if(firstRun == 0)
            {
                firstRun = 1;
                getImage().setTransparency(255);
                GreenfootImage image = getImage();
                image.scale(800, 800);
                Greenfoot.delay(23);
                getWorld().addObject(new TitleLogo(), 451, 52);
                Menu ctrl = new Menu(-1);
                Menu simplectrl = new Menu(-2);
                Menu start = new Menu(0);
                Menu options = new Menu(1);
                Menu credits = new Menu(2);
                Menu simplestart = new Menu(3);
                getWorld().addObject(simplestart, 488, 454);
                getWorld().addObject(simplectrl, 0, 0);
                // getWorld().addObject(ctrl, 0, 0);
                // getWorld().addObject(start, 582, 381);
                // getWorld().addObject(options, 568, 414);
                // getWorld().addObject(credits, 568, 444);
            }
            if (getImage().getTransparency() >= 3)
            {
                fadeOut();
            }
            else
            {
                getImage().setTransparency(0);
                getWorld().removeObject(this);
            }
        }
    }
    
    /**
     * Fades in (+) by an increment of 7/255.
     */
    public void fadeIn()
    {
        getImage().setTransparency(getImage().getTransparency() + 7);
        Greenfoot.delay(1);
    }
    
    /**
     * Fades out (-) by an increment of 3/255.
     */
    public void fadeOut()
    {
        getImage().setTransparency(getImage().getTransparency() - 3);
        Greenfoot.delay(1);
    }
}
