import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This actor creates and handles the notifications on the loading screen
 * for enabling debug mode or skipping the title screen.
 * 
 * If its respective key is pressed ("D" for debug and "Q" for title skip),
 * it'll set a variable and dissapear.
 */

public class Notification extends Actor
{
    private int type;
    public static int quick;
    
    /**
     * Grabs information from its parent, then sets itself to an image accordingly.
     */
    public Notification(int type_)
    {
        quick = 0;
        type = type_;
        if(type_ == 0){
        setImage("images/debug.png");
        }
        else if(type_ == 1){
        setImage("images/quickmatch.png");
        }
    }
    
    /**
     * Executes either the debug or quick function, depending on what type of notification this is.
     */
    public void act()
    {
        if(type == 0){
            setLocation(131, 21);
            debug();
        }
        else if(type == 1){
            setLocation(253, 45);
            quick();
        }
    }
    
    /**
     * Checks for key "D" being pressed.
     * 
     * If so, hide this object.
     */
    public void debug()
    {
        if(Greenfoot.isKeyDown("d"))
            {
                getWorld().removeObject(this);
            }
    }
    
    /**
     * Checks for key "Q" being pressed.
     * 
     * If so, hide this object and set variable "quick" to one.
     * 
     * This tells the loader to skip the menu/intro and load into world Game instead.
     */
    public void quick()
    {
        if(Greenfoot.isKeyDown("q"))
        {
            getWorld().removeObject(this);
            quick = 1;
        }
    }
}
