import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This actor handles the particles on the title screen!
 */
public class TitleParticle extends Actor
{
    private int firstRun = 0;
    private int vY = 0;
    private int transP = 10;
    private int frameLimit = 0;
    
    /**
     * Initializes some variables and performs some ~randomization~.
     * After first run, it just excecutes the method "move",
     */
    public void act()
    {
        if(firstRun == 0)
        {
            setLocation(Greenfoot.getRandomNumber(getWorld().getWidth() - 30),getWorld().getHeight() + 20);
            vY = Greenfoot.getRandomNumber(7) + 12;
            transP = 10;
            GreenfootImage image = getImage();
            image.scale(image.getWidth() * 3, image.getHeight() * 3);
            getImage().setTransparency(166);
            firstRun = 1;
        }
        move();
    }
    
    /**
     * Every other frame, this function moves the particle upwards by
     * the randomized variable vY and makes it more transparent by the
     * amount of variable transP.
     */
    public void move()
    {
        if(getImage().getTransparency() >= 9)
        {
            if(frameLimit == 0)
            {
                setLocation(getX(), getY() - vY);
                getImage().setTransparency(getImage().getTransparency() - transP);
                frameLimit++;
            }
            else
            {
                frameLimit = 0;
            }
        }
        else
        {
            getImage().setTransparency(0);
            getWorld().removeObject(this);
        }
    }
}
